/*
 * Public domain
 */
#ifndef H_<"$COMP">_SPINLOCK
#define H_<"$COMP">_SPINLOCK

#ifndef __APPLE__

# include <pthread.h>

#else /* __APPLE__ */

# include <libkern/OSAtomic.h>

typedef OSSpinLock pthread_spinlock_t;

static __inline__ int
pthread_spin_init(pthread_spinlock_t *lock, int pshared)
{
  *lock = 0;
  return 0;
}

static __inline__ int
pthread_spin_destroy(pthread_spinlock_t *lock)
{
  return 0;
}

static __inline__ int
pthread_spin_lock(pthread_spinlock_t *lock)
{
  OSSpinLockLock(lock);
  return 0;
}

static __inline__ int
pthread_spin_unlock(pthread_spinlock_t *lock)
{
  OSSpinLockUnlock(lock);
  return 0;
}

#endif /* __APPLE__ */

#endif /* H_<"$COMP">_SPINLOCK */
